from Globals import InitializeClass
from Products.CMFDefault.Document import Document
from AccessControl import ClassSecurityInfo
from Permissions import p_manageRSSStory, p_View

factory_type_information = ( { 'id'             : 'RSSStory'
                             , 'meta_type'      : 'RSSStory'
                             , 'description'    : """ """
                             , 'icon'           : 'rssstory_icon.gif'
                             , 'product'        : 'CMFAggregator'
                             , 'factory'        : 'addRSSStory'
                             , 'immediate_view' : 'metadata_edit_form'
                             , 'actions'        :
                                ( { 'id'            : 'view'
                                  , 'name'          : 'View'
                                  , 'action'        : 'rssstory_view'
                                  , 'permissions'   : (p_View, )
                                  }
                                , { 'id'            : 'edit'
                                  , 'name'          : 'Edit'
                                  , 'action'        : 'portal_form/rssstory_edit_form'
                                  , 'permissions'   : (p_manageRSSStory, )
                                  }
                                , { 'id'            : 'metadata'
                                  , 'name'          : 'Metadata'
                                  , 'action'        : 'metadata_edit_form'
                                  , 'permissions'   : (p_manageRSSStory, )
                                  }
                                )
                             }
                           ,
                           )

def addRSSStory( self
               , id
               , title=''
               , description=''
               , link=''
               ):
    """
        Add a RSSStory
    """
    o=RSSStory( id=id
              , title=title
              , description=description
              , link=link
              )
    self._setObject(id, o)

class RSSStory( Document ):
    """
        A RSS Story
    """

    __implements__ = Document.__implements__

    meta_type='RSSStory'

    text_format = 'html'

    security = ClassSecurityInfo()

    def __init__(self, id, title='', description='', link=''):
        """ """
        self.id = id
        self.title = title
        self.description = description
        self.link = link

    security.declareProtected( p_manageRSSStory, 'edit' )
    def edit( self, title='', description='',link='', text_format='html'):
        """
            Edit the RSS Story
        """
        self.title = title
        self.description = description
        self.link = link
        self.text_format = text_format

InitializeClass( RSSStory )